Rivet::Thrust Class Reference

Get the e+ e- thrust basis and the thrust, thrust major and thrust minor scalars. More...

`#include <Thrust.hh>`

Inheritance diagram for Rivet::Thrust:

## Public Member Functions

| Thrust ()
| Constructor.
| Thrust (const FinalState &fsp)
virtual const Projection * | clone () const
| Clone on the heap.
double | thrust () const
double | thrustMajor () const
| The thrust major scalar, , (thrust along thrust major axis).
double | thrustMinor () const
| The thrust minor scalar, , (thrust along thrust minor axis).
double | oblateness () const
| The oblateness, .
const Vector3 & | thrustAxis () const
const Vector3 & | thrustMajorAxis () const
| The thrust major axis (axis of max thrust perpendicular to thrust axis).
const Vector3 & | thrustMinorAxis () const
| The thrust minor axis (axis perpendicular to thrust and thrust major).
const Vector3 & | axis1 () const
| AxesDefinition axis accessors.
const Vector3 & | axis2 () const
| The 2nd most significant ("major") axis.
const Vector3 & | axis3 () const
| The least significant ("minor") axis.
Direct methods
Ways to do the calculation directly, without engaging the caching system
void | calc (const FinalState &fs)
| Manually calculate the thrust, without engaging the caching system.
void | calc (const vector< Particle > &fsparticles)
| Manually calculate the thrust, without engaging the caching system.
void | calc (const vector< FourMomentum > &fsmomenta)
| Manually calculate the thrust, without engaging the caching system.
void | calc (const vector< Vector3 > &threeMomenta)
| Manually calculate the thrust, without engaging the caching system.
Public Member Functions inherited from Rivet::AxesDefinition
virtual | ~AxesDefinition ()
| Virtual destructor.
Public Member Functions inherited from Rivet::Projection
bool | before (const Projection &p) const
virtual const std::set< PdgIdPair > | beamPairs () const
virtual std::string | name () const
| Get the name of the projection.
Projection & | addPdgIdPair (PdgId beam1, PdgId beam2)
| Add a colliding beam pair.
Log & | getLog () const
| Get a Log object based on the getName() property of the calling projection object.
void | setName (const std::string &name)
| Used by derived classes to set their name.
| Projection ()
| The default constructor.
virtual | ~Projection ()
| The destructor.
Public Member Functions inherited from Rivet::ProjectionApplier
| ProjectionApplier ()
| Constructor.
std::set< ConstProjectionPtr > | getProjections () const
| Get the contained projections, including recursion.
template<typename PROJ >
const PROJ & | getProjection (const std::string &name) const
| Get the named projection, specifying return type via a template argument.
const Projection & | getProjection (const std::string &name) const
template<typename PROJ >
const PROJ & | applyProjection (const Event &evt, const PROJ &proj) const
| Apply the supplied projection on event.
template<typename PROJ >
const PROJ & | applyProjection (const Event &evt, const Projection &proj) const
| Apply the supplied projection on event.
template<typename PROJ >
const PROJ & | applyProjection (const Event &evt, const std::string &name) const
| Apply the named projection on event.

## Protected Member Functions

void | project (const Event &e)
| Perform the projection on the Event.
int | compare (const Projection &p) const
| Compare projections.
Protected Member Functions inherited from Rivet::Projection
Cmp< Projection > | mkNamedPCmp (const Projection &otherparent, const std::string &pname) const
Cmp< Projection > | mkPCmp (const Projection &otherparent, const std::string &pname) const
Protected Member Functions inherited from Rivet::ProjectionApplier
Log & | getLog () const
ProjectionHandler & | getProjHandler () const
| Get a reference to the ProjectionHandler for this thread.
template<typename PROJ >
const PROJ & | addProjection (const PROJ &proj, const std::string &name)

## Detailed Description

Get the e+ e- thrust basis and the thrust, thrust major and thrust minor scalars.

Author
  Andy Buckley

The scalar (maximum) thrust is defined as

, with the direction of the unit vector which maximises being identified as the thrust axis. The unit vector which maximises the thrust scalar in the plane perpendicular to is the "thrust major" direction, and the vector perpendicular to both the thrust and thrust major directions is the thrust minor. Both the major and minor directions have associated thrust scalars.

Thrust calculations have particularly simple forms for less than 4 particles, and in those cases this projection is computationally minimal. For 4 or more particles, a more general calculation must be carried out, based on the Brandt/Dahmen method from Z. Phys. C1 (1978). While a polynomial improvement on the exponential scaling of the naive method, this algorithm scales asymptotically as . Be aware that the thrust may easily be the most computationally demanding projection in Rivet for large events!

The Rivet implementation of thrust is based heavily on Stefan Gieseke's Herwig++ re-coding of the 'tasso' code from HERWIG.

NB. special case with >= 4 coplanar particles will still fail. NB. Thrust assumes all momenta are in the CoM system: no explicit boost is performed. This can be dealt with by appropriate choice of the supplied FinalState.

## Member Function Documentation

## thrust()

double Rivet::Thrust::thrust | ( |  | ) | const

inline

Thrust scalar accessors The thrust scalar, , (maximum thrust).

## thrustAxis()

const Vector3& Rivet::Thrust::thrustAxis | ( |  | ) | const

inline

Thrust axis accessors The thrust axis.

Referenced by axis1().

The documentation for this class was generated from the following files:

- include/Rivet/Projections/Thrust.hh
- src/Projections/Thrust.cc